#include <Magick++.h>
#include <iostream>
    
using namespace std;
using namespace Magick;

#define WIDTH  40
#define HEIGHT 20
Image target(Geometry(WIDTH,HEIGHT), Color(0,0,0));

void clear(const char* fileName)
{
    Image source;

    try
    {
// Read a file into image object
	source.read(fileName);

	if ((source.columns() != WIDTH) || (source.rows() != HEIGHT))
	{
	    printf ("ERROR: strange geometry %dx%d\n", source.columns(), source.rows());
	    exit(1);
	}

// clear target
	for (int x=0; x < WIDTH; x++)
	{
	    for (int y=0; y < HEIGHT; y++)
	    {

		PixelPacket *pSourcePixel = source.getPixels(x,y,1,1);
		PixelPacket *pTargetPixel = target.getPixels(x,y,1,1);

		if ((pTargetPixel->red == 0) && (pTargetPixel->green == 0) && (pTargetPixel->blue == 0))
		{
		    if ((pSourcePixel->red != 0) || (pSourcePixel->green != 0) || (pSourcePixel->blue != 0))
		    {
			pTargetPixel->red   = pSourcePixel->red;
			pTargetPixel->green = pSourcePixel->green;
			pTargetPixel->blue  = pSourcePixel->blue;
		    }
		}
	    }
	}

    }
    catch( Exception &error_ )
    {
	cout << "Caught exception: " << error_.what() << endl;
	exit(1);
    }

}
    
int main(int argc, char* argv[])
{
    if (argc == 1)
    {
	printf ("Example %s *gif\n", argv[0]);
	exit(1);
    }
    
    for (int i=1; i < argc; i++)
    {
	clear(argv[i]);
    }
    
    try
    {
	target.write("clear.png");
    }
    catch( Exception &error_ )
    {
	cout << "Caught exception: " << error_.what() << endl;
	exit(1);
    }

    return 0;
}
