#include <Magick++.h>
#include <iostream>
    
using namespace std;
using namespace Magick;

#define WIDTH  40
#define HEIGHT 20
Image source; //(Geometry(WIDTH,HEIGHT), Color(0,0,0));

int number = 0;

bool check(Image& target, int offset)
{

    for (int x=0; x < WIDTH; x++)
    {
	for (int y=0; y < HEIGHT; y++)
	{

	    PixelPacket *pTargetPixel = target.getPixels(x,y,1,1);
	    PixelPacket *pSourcePixel = source.getPixels(x,y,1,1);

	    if ((pTargetPixel->red == 0) && (pTargetPixel->green == 0) && (pTargetPixel->blue == 0))
	    {
		if ((pSourcePixel->red != 0) || (pSourcePixel->green != 0) || (pSourcePixel->blue != 0))
		{
/*
		    printf ("bad x=%d y=%d\n", x, y);
		    printf ("pTargetPixel->red   =%X\n", pTargetPixel->red);
		    printf ("pTargetPixel->green =%X\n", pTargetPixel->green);
		    printf ("pTargetPixel->blue  =%X\n", pTargetPixel->blue);

		    printf ("pSourcePixel->red   =%X\n", pSourcePixel->red);
		    printf ("pSourcePixel->green =%X\n", pSourcePixel->green);
		    printf ("pSourcePixel->blue  =%X\n", pSourcePixel->blue);
*/
		    return false;
		}
/*
		    printf ("ok x=%d y=%d\n", x, y);
		    printf ("pTargetPixel->red   =%X\n", pTargetPixel->red);
		    printf ("pTargetPixel->green =%X\n", pTargetPixel->green);
		    printf ("pTargetPixel->blue  =%X\n", pTargetPixel->blue);

		    printf ("pSourcePixel->red   =%X\n", pSourcePixel->red);
		    printf ("pSourcePixel->green =%X\n", pSourcePixel->green);
		    printf ("pSourcePixel->blue  =%X\n", pSourcePixel->blue);
*/
	    }
	}
    }

    number+=offset;
    return true;
}

int main(int argc, char* argv[])
{
    if (argc != 2)
    {
	printf ("Example %s unknown.gif\n", argv[0]);
	exit(1);
    }
    
    try
    {
	source.read(argv[1]);
	if ((source.columns() != WIDTH) || (source.rows() != HEIGHT))
	{
	    printf ("ERROR: strange image0\n");
	    exit(1);
	}
    
        Image mask_1xx;
        Image mask_2xx;
        Image mask_3xx;
        Image mask_4xx;
        Image mask_5xx;
        Image mask_6xx;
        Image mask_7xx;
        Image mask_8xx;
        Image mask_9xx;
	Image mask_x0x;
        Image mask_x1x;
        Image mask_x2x;
        Image mask_x3x;
        Image mask_x4x;
        Image mask_x5x;
        Image mask_x6x;
        Image mask_x7x;
        Image mask_x8x;
        Image mask_x9x;
        Image mask_xx0;
        Image mask_xx1;
        Image mask_xx2;
        Image mask_xx3;
        Image mask_xx4;
        Image mask_xx5;
        Image mask_xx6;
        Image mask_xx7;
        Image mask_xx8;
        Image mask_xx9;

        mask_1xx.read("mask_images/mask_1xx.png");
        mask_2xx.read("mask_images/mask_2xx.png");
        mask_3xx.read("mask_images/mask_3xx.png");
        mask_4xx.read("mask_images/mask_4xx.png");
        mask_5xx.read("mask_images/mask_5xx.png");
        mask_6xx.read("mask_images/mask_6xx.png");
        mask_7xx.read("mask_images/mask_7xx.png");
        mask_8xx.read("mask_images/mask_8xx.png");
        mask_9xx.read("mask_images/mask_9xx.png");
        mask_x0x.read("mask_images/mask_x0x.png");
        mask_x1x.read("mask_images/mask_x1x.png");
        mask_x2x.read("mask_images/mask_x2x.png");
        mask_x3x.read("mask_images/mask_x3x.png");
        mask_x4x.read("mask_images/mask_x4x.png");
        mask_x5x.read("mask_images/mask_x5x.png");
        mask_x6x.read("mask_images/mask_x6x.png");
        mask_x7x.read("mask_images/mask_x7x.png");
        mask_x8x.read("mask_images/mask_x8x.png");
        mask_x9x.read("mask_images/mask_x9x.png");
        mask_xx0.read("mask_images/mask_xx0.png");
        mask_xx1.read("mask_images/mask_xx1.png");
        mask_xx2.read("mask_images/mask_xx2.png");
        mask_xx3.read("mask_images/mask_xx3.png");
        mask_xx4.read("mask_images/mask_xx4.png");
        mask_xx5.read("mask_images/mask_xx5.png");
        mask_xx6.read("mask_images/mask_xx6.png");
        mask_xx7.read("mask_images/mask_xx7.png");
        mask_xx8.read("mask_images/mask_xx8.png");
        mask_xx9.read("mask_images/mask_xx9.png");

	
	for(;;)
	{
	    if (check(mask_8xx, 800)) break;
	    if (check(mask_9xx, 900)) break;
	    if (check(mask_3xx, 300)) break;

	    if (check(mask_1xx, 100)) break;
	    if (check(mask_2xx, 200)) break;
	    if (check(mask_4xx, 400)) break;
	    if (check(mask_7xx, 700)) break;

	    if (check(mask_6xx, 600)) break;
	    if (check(mask_5xx, 500)) break;

	    printf ("ERROR: strange image1\n");
	    exit(1);
	}

	for(;;)
	{
	    if (check(mask_x8x, 80)) break;
	    if (check(mask_x9x, 90)) break;
	    if (check(mask_x3x, 30)) break;

	    if (check(mask_x1x, 10)) break;
	    if (check(mask_x2x, 20)) break;
	    if (check(mask_x4x, 40)) break;
	    if (check(mask_x7x, 70)) break;

	    if (check(mask_x6x, 60)) break;
	    if (check(mask_x5x, 50)) break;

	    if (check(mask_x0x,  0)) break;

	    printf ("ERROR: strange image2\n");
	    exit(1);
	}

	for(;;)
	{
	    if (check(mask_xx8, 8)) break;
	    if (check(mask_xx9, 9)) break;
	    if (check(mask_xx3, 3)) break;

	    if (check(mask_xx1, 1)) break;
	    if (check(mask_xx2, 2)) break;
	    if (check(mask_xx4, 4)) break;
	    if (check(mask_xx7, 7)) break;

	    if (check(mask_xx6, 6)) break;
	    if (check(mask_xx5, 5)) break;

	    if (check(mask_xx0, 0)) break;

	    printf ("ERROR: strange image3\n");
	    exit(1);
	}

	printf ("%d\n", number);
    }
    catch( Exception &error_ )
    {
	cout << "Caught exception: " << error_.what() << endl;
	exit(1);
    }

    return 0;
}
